/*
---------------------------------------------------------------------------
 Algo4-3.c   C program for implementing Algorithm 4.3
 Algorithm translated to  C  by: Dr. Norman Fahrer
 IBM and Macintosh verification by: Daniel Mathews
 
 NUMERICAL METHODS: C Programs, (c) John H. Mathews 1995
 To accompany the text:
 NUMERICAL METHODS for Mathematics, Science and Engineering, 2nd Ed, 1992
 Prentice Hall, Englewood Cliffs, New Jersey, 07632, U.S.A.
 Prentice Hall, Inc.; USA, Canada, Mexico ISBN 0-13-624990-6
 Prentice Hall, International Editions:   ISBN 0-13-625047-5
 This free software is compliments of the author.
 E-mail address:       in%"mathews@fullerton.edu"
 
 Algorithm 4.3 (Lagrange Approximation).
 Section   4.3, Lagrange Approximation, Page 224
---------------------------------------------------------------------------
*/
/*
---------------------------------------------------------------------------
 
 Algorithm 4.3 (Lagrange Approximation).

 To evalutate the Lagrange polynomial 
           
           N                           
 P(x)  =  SUM y_k * L_(N,k)(x),   of degree  N, based on the
          k=0
 
 N+1  points  (x_k,y_k)  for  k = 0,1,...,N.

---------------------------------------------------------------------------
*/

/* main for algo4-3.c  page 224 */

/* if compiling with the djgpp C-compiler then include 
   the library : libpc with  -lpc
   Example :  gcc algo4-5.c -lm -lpc                      */
   

#include<math.h>
#include<stdio.h>
#include<stdlib.h>

#define MAX 20

void main(void)
{

int N;                         /* Degree of P(x)  :  INPUT         */
int K, J;                      /* Loop counters                    */
double X[MAX], Y[MAX];         /* INPUT : Abscissas of the points  */
                               /* INPUT : Ordinates of the points  */
double Sum;                    
double T;                      /* Independent variable             */
double Term;
int  q;                        /* For comparison to end input loop */           
       
    

    printf("-----------------------------------------------------\n");
    printf("Try examples on page 225 !\n");

    do
    {
      printf("Please enter degree of P[x] (Not > 20):\n");
      scanf("%d", &N);
    } while( N > MAX);

    printf("-----------------------------------------------------\n");
    printf("Degree of as entered is : %d\n", N);
    printf("-----------------------------------------------------\n");

    printf("Now enter all the x and y values.\n");
    printf("Not more then %d = [0 - %d] !\n", N+1, N);

    for( J = 0; J <= N; J++) 
    {
     printf("Please enter : x_%d, y_%d\n", J,J);
     scanf("%lf, %lf", &X[J], &Y[J]);
     printf("You entered : x,y : %lf %lf\n",X[J], Y[J]);
    }

     
    printf("-----------------------------------------------------\n");
    printf("Now comes a LOOP for input of the independent variable.\n");       
    printf("-----------------------------------------------------\n");
    for(; ; )
    {
     printf("TYPE  q  IF you want to STOP, else any other key.\n");
     q = getch();

     if( q == 'q') break ;

     printf("Ok. You want to continue, so.....\n");
     printf("Please enter the independent variable X :\n");
     scanf("%lf", &T);

     Sum = 0.0;   /* initialize variable */

     /* Form terms to be added  */
     for( K = 0; K <= N; K++)
     {
       Term = Y[K];
       for(J = 0; J <= N; J++)
       {
         /* To avoid division by zero. */
         if(J != K) Term = Term * (T - X[J]) / (X[K] - X[J]);

       }
       Sum += Term;
     }

      /* output */
      printf("--------------------------------------------------\n");
      printf("The value of the Lagrange interpolating polynomial\n");
      printf("based on the nodes :\n");
      printf(" No.    x_No.        y_No.\n");
      for(J = 0; J <= N; J++) printf("%d  %lf  %lf\n", J, X[J], Y[J]);
      printf("is : %lf\n", Sum);
    }
}

