/*
---------------------------------------------------------------------------
 Algo5-1.c   C program for implementing Algorithm 5.1
 Algorithm translated to  C  by: Dr. Norman Fahrer
 IBM and Macintosh verification by: Daniel Mathews
 
 NUMERICAL METHODS: C Programs, (c) John H. Mathews 1995
 To accompany the text:
 NUMERICAL METHODS for Mathematics, Science and Engineering, 2nd Ed, 1992
 Prentice Hall, Englewood Cliffs, New Jersey, 07632, U.S.A.
 Prentice Hall, Inc.; USA, Canada, Mexico ISBN 0-13-624990-6
 Prentice Hall, International Editions:   ISBN 0-13-625047-5
 This free software is compliments of the author.
 E-mail address:       in%"mathews@fullerton.edu"
 
 Algorithm 5.1 (Least Squares Line).
 Section   5.1, Least-Squares Line, Page 264
---------------------------------------------------------------------------
*/
/*
---------------------------------------------------------------------------
 
 Algorithm 5.1 (Least-Squares Line).
 To  construct the least-squares line  y = Ax + B  that fits the
 N  data points (x_1,y_1),...,(x_N,Y_N).

 Remark: The algorithm is computationally stable : it gives
         reliable results in cases when the linear system (15)
         is ill-conditioned (see Exercise 5).

---------------------------------------------------------------------------
*/

#include<stdio.h>
#include<stdlib.h>
#include<math.h>


/*  Main program for algorithm 5.1  */

    void main()

{
    int K;                     /* loop counter                   */
    int N;                     /* INPUT: Number of points        */
    double A, B;               /* Slope and Y-intersection       */
    double X[20];              /* x-coordinates of points        */
    double Y[20];              /* y-coordinates of points        */
    double Xmean;              /* Average value for x coord.     */
    double Ymean;              /* Average value for y coord.     */
    double SumX;               /* Sum of X coordinate values     */
    double SumXY;              /* Sum of product X*Y             */

    printf("--------Try exercise 1.a----page 265--------------\n");
    printf("Please enter number N of data points:\n");
    printf("EXAMPLE: N = 5, so type: 5\n");
    scanf("%d",&N);
    if(N > 21)
    {
     printf(" Not prepared for more than 21 points. Terminating. Sorry\n");
     exit(0);
    }

    printf("The number of data points  N =  %d\n", N);
    printf("----------------------------------------------\n");

        printf("INPUT of data points :\n");
        printf("Example : x = -2 and y = 1, so type : -2 1\n");
        printf(" \n");

    for(K = 1; K <= N; K++)
    {
        printf("data point number %d please.\n",K);
        scanf("%lf %lf", &X[K-1],&Y[K-1]);
    }

    Xmean = 0.0;

    /* calculate X-mean value */

    for(K = 1; K <= N; K++) Xmean = Xmean + X[K-1];
    Xmean = Xmean / N;

    Ymean = 0.0;

    /* calculate Y-mean value */

    for(K = 1; K <= N; K++) Ymean = Ymean + Y[K-1];
    Ymean = Ymean / N;


    SumX = 0.0;

    /* Sum (x_k - Xmean) squared */

    for(K = 1; K <= N; K++) SumX = SumX + pow( (X[K-1] - Xmean),2 );


     SumXY = 0.0;

    /* Sum (x_k - Xmean) * (Y_k - Ymean) */

    for(K = 1; K <= N; K++) SumXY = SumXY +
                            ( (X[K-1] - Xmean) * (Y[K-1] - Ymean) );


    A = SumXY/SumX;         /* Compute the slope          */
    B = Ymean - A * Xmean;  /* Compute the y-intersection */


    printf("----------------------------------------------\n");
    printf(" Least-square line y = Ax + B\n");
    printf(" The coefficients are :\n");
    printf(" A = %lf and B = %lf .\n", A, B);
    printf("----------------------------------------------\n");

}   /* End of main programm */

